Bug 1268424 - [GSS](6.4.z) SFSB infinite loop if Passivate fails
[GSS](6.4.z) SFSB infinite loop if Passivate fails
Status: CLOSED CURRENTRELEASE
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: EJB, Clustering (Show other bugs)
6.4.0
Unspecified Unspecified
high Severity unspecified
: CR1
: EAP 6.4.5
Assigned To: Tomas Hofman
Jan Martiska
https://github.com/jbossas/jboss-eap/...
:
Depends On:
Blocks: 1235745
  Show dependency treegraph
 
Reported: 2015-10-02 15:22 EDT by Brad Maxwell
Modified: 2017-01-17 06:42 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
JBoss Issue Tracker WFLY-5496 Major Resolved Add a testcase testing passivation of SFSB which fails to serialize 2017-03-07 22:06 EST

  None (edit)
Description Brad Maxwell 2015-10-02 15:22:17 EDT
If a Stateful Session Bean is accessed and then goes into passivation and an exception occurs, the next call to get the SFSB gets stuck in an infinite loop looking for the SFSB key in this class:

ejb3/src/main/java/org/jboss/as/ejb3/cache/impl/backing/PassivatingBackingCacheImpl.java

It appears PassivateTask is scheduled with a thread pool, it attempts the passivation and logs the exception that occurs, but the SFSB key does not appear to be removed when passivation fails, this results in the infinite loop above.

./src/main/java/org/jboss/as/ejb3/cache/spi/impl/PassivateTask.java
Comment 5 Tomas Hofman 2015-10-05 08:04:45 EDT
I presume this is free to take Brad?
Comment 6 Carlo de Wolf 2015-10-05 08:11:30 EDT
If a SFSB fails to passivate it should not be destroyed. (Though this is allowed by spec.)
This might become a configuration option in the future.

Thus bug is purely about the infinite loop that occurs.
Comment 9 Tomas Hofman 2015-10-07 07:49:54 EDT
PR: https://github.com/jbossas/jboss-eap/pull/2580

In the end I decided not to destroy the bean but call postActivate() and leave it active instead. Asked Paul for review.
Comment 12 JBoss JIRA Server 2015-10-08 11:24:58 EDT
Tomas Hofman <thofman@redhat.com> updated the status of jira WFLY-5496 to Coding In Progress
Comment 16 Jan Martiska 2015-11-03 08:11:09 EST
Verified with EAP 6.4.5.CR1.
The newly added PassivationSucceedsUnitTestCase fails intermittently, there will be a separate BZ to resolve it.
Comment 17 Petr Penicka 2017-01-17 06:42:33 EST
Retroactively bulk-closing issues from released EAP 6.4 cumulative patches.
Comment 18 Petr Penicka 2017-01-17 06:42:54 EST
Retroactively bulk-closing issues from released EAP 6.4 cumulative patches.

Note You need to log in before you can comment on or make changes to this bug.